(* -------------------------------------------------------------*)
(*								*)
(*			Exp.ml:					*)
(*								*)
(* ------------------------------------------------------------ *)

print_depth 1;

signature EXP =
  sig
   structure ExpRow: EXPROW
  val sign: Sign.sg
  val thy: theory
  val spec :  (string * string) list
end;

functor ExpFun 
 (structure ExpRow : EXPROW) : EXP =  
struct
structure ExpRow = ExpRow;
local open Syntax 
in

val spec =
					 (* Rule 111 is not needed   *)
    [("Apply",				 (* Rules 112, 113, 116, 117  *)
	 "((EX c v. E |- exp ~> <con c> in1Val'  & \
       \   E |- atexp ~> v in1Val'  & v' = <con c,v> in1Val' ) | \
       \   (EX en v.E |- exp ~> <exname en> in1Val'  & \
       \        E |- atexp ~> v in1Val'  & \
       \        v' = <exname en,v> in1Val') | \
       \   (EX b v1.E |- exp ~> b in1Val' & E |- atexp ~> v1 in1Val' & \
       \       apply <b, v1, v2> & v' = v2 in1Val') | \
       \   (EX match E' VE v VE' E''.                       \
       \    E |- exp ~> closure (match, E', VE) in1Val'\
       \     & E |- atexp ~> v in1Val' &   \
       \      unfold (VE,VE,VE') &                          \
       \       Combine (E', <{| |}, VE', {| |}>, E'')  &    \
       \    E'', v |- match ~> v' [Match] )) <->    \
       \    E |- exp`atexp ~> v' "),
    			 (* Rules 114 is ref, 115 is assign - omitted *)
    			 	 (* Rules 114-115, 118 - 122 omitted *)
     ("Fn",				        (* Rule 123 *)
         "v = closure (match,E,{| |}) <-> E |- fn match ~> v in1Val'")];


val thy = extend_theory ExpRow.thy "EXP"
     ([], [], [], [], [], None)  spec;   

val sign = sign_of thy;

end;
end;
